#ifndef ADVANCE_H
#define ADVANCE_H
// $Id: advance.h,v 1.1 2001/08/14 07:42:41 dvermeir Exp $

#include <iterator>
#include <iostream>

// Illustrate dispatching on iterator category to obatin an adaptable
// algorithm.

template <class InputIterator>
void // version for input iterators and forward iterators
myadvance_(InputIterator& i,
           typename iterator_traits<InputIterator>::difference_type n,
	   input_iterator_tag) {
cout << "running input_iterator_tag version" << endl;
for (; n>0 ; --n)
  ++i;
}

template <class BidirectionalIterator>
void // version for bidirectional iterator
myadvance_(BidirectionalIterator& i,
           typename iterator_traits<BidirectionalIterator>::difference_type n,
	   bidirectional_iterator_tag) {
cout << "running bidirectional_iterator_tag version" << endl;
if (n>=0)
  for (; n>0 ; --n) ++i;
else
  for (; n<0 ; ++n) --i;
}

template <class RandomAccessIterator>
void // version for random access iterators
myadvance_(RandomAccessIterator& i,
           typename iterator_traits<RandomAccessIterator>::difference_type n,
	   random_access_iterator_tag) {
cout << "running random_iterator_tag version" << endl;
i += n;
}

template <class InputIterator>
void
myadvance(InputIterator& i,
  	  typename iterator_traits<InputIterator>::difference_type n) {
myadvance_(i,n,typename iterator_traits<InputIterator>::iterator_category());
}
#endif
