// $Id: findllist.C,v 1.1 2001/08/12 13:08:47 dvermeir Exp $

// Sequential search in a (singly) linked list.

#include	<iostream>

template <typename T>
class Node { // Node* is a (too) simple linked list
public:
  // You cannot make an empty list.
  Node(const T& t): value_(t), cdr_(0) {} 
  // Prepend a node containing t.
  Node*	cons(const T& t) { return new Node(t,this); } 
  // Return data in first node.
  const T&	car() const { return value_; } 
  // Return rest of list (after first node).
  Node*	cdr() const { return cdr_; }
private:
  Node(const T& t,Node* cdr): value_(t), cdr_(cdr) {}

  T		value_;
  Node*		cdr_;
};

template <typename T>
Node<T>*
find(Node<T>* first, Node<T>* last,const T& value) {
// Sequential search for value in linked list [first .. last[
// return last if not found.
while (first!=last && first->car()!=value) 
  first = first->cdr();
return first;
}

int
main() {
Node<int>*	list(new Node<int>(10));
Node<int>*	null(0);

for (int i=0; i<100; ++i)
  list = list->cons(i);

cout << find(list, null, 96)->car() << endl;

}
