// $Id: sum2.C,v 1.1 2001/08/14 07:14:27 dvermeir Exp $

// A demo showing the use of the sum() kludge from sum2.h

#include	<assert.h>
#include	<iostream>
#include	"sum2.h"

// Node* is a (too) simple linked list.
template <typename T>
class Node { 
public:
  Node(const T& t): value_(t), cdr_(0) {} // you cannot make an empty list
  Node*	cons(const T& t) { return new Node(t,this); } // prepend
  const T&	car() const { return value_; } // non const version missing
  Node*	cdr() const { return cdr_; } // non const version missing
  
  ///////////////////////////////////////////////////////////////////
  // Iterator class type satisfying requirements for find.
  class Cursor { 
  public:
    Cursor(Node* node=0): node_(node) {}
    const T& operator*() const { assert(node_); return node_->car(); }
    Cursor& operator++() { 
      assert(node_); 
      node_ = node_->cdr(); 
      return *this; 
    }
    Cursor operator++(int) { 
      Cursor tmp(*this); 
      ++*this; 
      return tmp; 
      }
    bool operator!=(const Cursor& c) const { 
      return node_ != c.node_; }
    bool operator==(const Cursor& c) const { 
      return node_ == c.node_; }
  private:
    Node*	node_;
  };
  //
  ///////////////////////////////////////////////////////////////////

private:
  Node(const T& t,Node* cdr): value_(t), cdr_(cdr) {}
  T		value_;
  Node*		cdr_;
};

int
main() {
Node<int>*	list(new Node<int>(0));

for (int i=1; i<100; ++i)
  list = list->cons(i);

int	total(0);
cout << sum(Node<int>::Cursor(list), Node<int>::Cursor(),total) << endl;
}
