#ifndef	WORD_H
#define	WORD_H
// $Id: word.h,v 1.1 2001/08/14 07:53:03 dvermeir Exp $

// A simple Word class.

#include	<string>
#include	<iostream>
#include	<ctype.h> // for isalpha()

class Word {
public:
  Word(const string& s=string("")): word_(s) {}
  const string& word() const { return word_; }
  friend istream&
    operator>>(istream&,Word&);
  friend ostream&
    operator<<(ostream& os,const Word& w) { return os << w.word(); }
  bool operator<(const Word& w) const { return word_ < w.word(); }
  bool operator==(const Word& w) const { return word_ == w.word(); }
private:
  string	word_;
};

inline istream&
operator>>(istream& is,Word& w) {
char c;
do // Skip until first alphabetic char.
  c = is.get();
while ((is) && (!isalpha(c)));
if (!is)
  return is;
w.word_ = ""; // Initialize word_ and then read consecutive letters.
while ((is) && isalpha(c)) {
  w.word_ += tolower(c); // append c 
  c = is.get();
  }
return is;
}
#endif
